module interaction.model;

import presentation.model;

final class Manipulator {
}

abstract class Selector {
    Selector(Fig selected) {
        _selected = selected;
    }

    Fig selected() { return _selected; }

    abstract void draw(Screen screen);

    private {
        Fig _selected;
    }
}

abstract class Fig {
    DiagramElement element() { return _element; }

    abstract void draw(Canvas canvas);

    abstract Selector create_selector();

    private {
        DiagramElement _element;
    }
}

abstract class NetFig : Fig {
    GraphElement element() { return _element; }

    private {
        GraphElement _element;
    }
}

abstract class EdgeFig : NetFig {
    GraphEdge element() { return _element; }

    private {
        GraphEdge _element;
    }
}

abstract class NodeFig : NetFig {
    GraphNode element() { return _element; }

    private {
        GraphNode _element;
    }
}
